using Godot;
using System;

[Tool]
public partial class GroupBox : PanelContainer
{
	private const string LABEL_PATH = "Control/Label";
	[Export] public string Text 
	{
		get => GetNode<Label>(LABEL_PATH)?.Text ?? string.Empty;
		set
		{
			var label = GetNode<Label>(LABEL_PATH);
			if (label != null && value != label.Text)
			{
				label.Text    = value;
				label.Visible = label.Text != string.Empty;
			}
		}
	}
}