using Godot;
using System;

public partial class BlockEditor : Window
{
	[Export] public Block Block {get; set; }

	public void _ImageButtonPressed()
	{

	}

	public void _ImageSpeedChanged(float value)
	{
		if (Block != null) Block.ImageSpeed = (int)value; 
	}

	public void _ImageFramesChanged(float value)
	{
		if (Block != null) Block.ImageFrames = (uint)value; 
	}

	public void _GfxOffsetXChanged(float value)
	{
		if (Block != null) Block.GfxBoundsOverride = new
		(
			(int)value,
			Block.GfxBoundsOverride.Position.Y,
			Block.GfxBoundsOverride.Size.X,
			Block.GfxBoundsOverride.Size.Y
		);
	}

	public void _GfxOffsetYChanged(float value)
	{
		if (Block != null) Block.GfxBoundsOverride = new
		(
			Block.GfxBoundsOverride.Position.X,
			(int)value,
			Block.GfxBoundsOverride.Size.X,
			Block.GfxBoundsOverride.Size.Y
		);
	}

	public void _GfxSizeXChanged(float value)
	{
		if (Block != null) Block.GfxBoundsOverride = new
		(
			Block.GfxBoundsOverride.Position.X,
			Block.GfxBoundsOverride.Position.Y,
			(int)value,
			Block.GfxBoundsOverride.Size.Y
		);	
	}

	public void _GfxSizeYChanged(float value)
	{
		if (Block != null) Block.GfxBoundsOverride = new
		(
			Block.GfxBoundsOverride.Position.X,
			Block.GfxBoundsOverride.Position.Y,
			Block.GfxBoundsOverride.Size.X,
			(int)value
		);	
	}

	public void _HitOffsetXChanged(float value)
	{
		if (Block != null) Block.HitBoundsOverride = new
		(
			(int)value,
			Block.HitBoundsOverride.Position.Y,
			Block.HitBoundsOverride.Size.X,
			Block.HitBoundsOverride.Size.Y
		);
	}

	public void _HitOffsetYChanged(float value)
	{
		if (Block != null) Block.HitBoundsOverride = new
		(
			Block.HitBoundsOverride.Position.X,
			(int)value,
			Block.HitBoundsOverride.Size.X,
			Block.HitBoundsOverride.Size.Y
		);
	}

	public void _HitSizeXChanged(float value)
	{
		if (Block != null) Block.HitBoundsOverride = new
		(
			Block.HitBoundsOverride.Position.X,
			Block.HitBoundsOverride.Position.Y,
			(int)value,
			Block.HitBoundsOverride.Size.Y
		);	
	}

	public void _HitSizeYChanged(float value)
	{
		if (Block != null) Block.HitBoundsOverride = new
		(
			Block.HitBoundsOverride.Position.X,
			Block.HitBoundsOverride.Position.Y,
			Block.HitBoundsOverride.Size.X,
			(int)value
		);		
	}
}
